#ifndef EFL_GENERATED_ECORE_AUDIO_OUT_PULSE_HH
#define EFL_GENERATED_ECORE_AUDIO_OUT_PULSE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_out_pulse.eo.h"
}

#include "ecore_audio_out.eo.hh"

struct ecore_audio_out_pulse
      : ecore_audio_out
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_out_pulse(Eo* eo)
      : ecore_audio_out(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_out_pulse(std::nullptr_t)
      : ecore_audio_out(nullptr)
   {}

   ecore_audio_out_pulse(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_out_pulse(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_out_pulse(ecore_audio_out_pulse const& other)
      : ecore_audio_out(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_out_pulse() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_context_ready_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_READY, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>,
         ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_READY );
   }

   template <typename T>
   void
   callback_context_ready_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_READY, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_context_fail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_FAIL, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>,
         ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_FAIL );
   }

   template <typename T>
   void
   callback_context_fail_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_FAIL, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OUT_PULSE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_AUDIO_OUT_PULSE_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_out_pulse >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_audio_out_pulse >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_out_pulse>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_out_pulse >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_out_pulse, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_audio_out_pulse >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_out_pulse, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::ecore_audio_out_pulse>
{
   template <typename U>
   struct type
   {
      operator ::ecore_audio_out_pulse() const
      {
         return ::ecore_audio_out_pulse(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_context_ready_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_READY, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>,
         ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_READY );
   }

   template <typename T>
   void
   callback_context_ready_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_READY, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_context_fail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_FAIL, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_out_pulse, function_type>,
         ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_FAIL );
   }

   template <typename T>
   void
   callback_context_fail_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_OUT_PULSE_EVENT_CONTEXT_FAIL, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_out_pulse>)
{
   return (ECORE_AUDIO_OUT_PULSE_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_OUT_PULSE_HH

